import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../../../common";
export interface IXGrailTokenInterface extends utils.Interface {
    functions: {
        "allocate(address,uint256,bytes)": FunctionFragment;
        "allocateFromUsage(address,uint256)": FunctionFragment;
        "allowance(address,address)": FunctionFragment;
        "approve(address,uint256)": FunctionFragment;
        "approveUsage(address,uint256)": FunctionFragment;
        "balanceOf(address)": FunctionFragment;
        "convertTo(uint256,address)": FunctionFragment;
        "deallocate(address,uint256,bytes)": FunctionFragment;
        "deallocateFromUsage(address,uint256)": FunctionFragment;
        "getUsageApproval(address,address)": FunctionFragment;
        "getUserRedeem(address,uint256)": FunctionFragment;
        "getUserRedeemsLength(address)": FunctionFragment;
        "getXGrailBalance(address)": FunctionFragment;
        "grailToken()": FunctionFragment;
        "isTransferWhitelisted(address)": FunctionFragment;
        "maxRedeemDuration()": FunctionFragment;
        "minRedeemDuration()": FunctionFragment;
        "redeem(uint256,uint256)": FunctionFragment;
        "totalSupply()": FunctionFragment;
        "transfer(address,uint256)": FunctionFragment;
        "transferFrom(address,address,uint256)": FunctionFragment;
        "usageAllocations(address,address)": FunctionFragment;
        "usagesDeallocationFee(address)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "allocate" | "allocateFromUsage" | "allowance" | "approve" | "approveUsage" | "balanceOf" | "convertTo" | "deallocate" | "deallocateFromUsage" | "getUsageApproval" | "getUserRedeem" | "getUserRedeemsLength" | "getXGrailBalance" | "grailToken" | "isTransferWhitelisted" | "maxRedeemDuration" | "minRedeemDuration" | "redeem" | "totalSupply" | "transfer" | "transferFrom" | "usageAllocations" | "usagesDeallocationFee"): FunctionFragment;
    encodeFunctionData(functionFragment: "allocate", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    encodeFunctionData(functionFragment: "allocateFromUsage", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "allowance", values: [PromiseOrValue<string>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "approve", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "approveUsage", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "balanceOf", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "convertTo", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "deallocate", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    encodeFunctionData(functionFragment: "deallocateFromUsage", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getUsageApproval", values: [PromiseOrValue<string>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "getUserRedeem", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getUserRedeemsLength", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "getXGrailBalance", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "grailToken", values?: undefined): string;
    encodeFunctionData(functionFragment: "isTransferWhitelisted", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "maxRedeemDuration", values?: undefined): string;
    encodeFunctionData(functionFragment: "minRedeemDuration", values?: undefined): string;
    encodeFunctionData(functionFragment: "redeem", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "totalSupply", values?: undefined): string;
    encodeFunctionData(functionFragment: "transfer", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "transferFrom", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "usageAllocations", values: [PromiseOrValue<string>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "usagesDeallocationFee", values: [PromiseOrValue<string>]): string;
    decodeFunctionResult(functionFragment: "allocate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "allocateFromUsage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "allowance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "approve", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "approveUsage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "balanceOf", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "convertTo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deallocate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deallocateFromUsage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUsageApproval", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUserRedeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUserRedeemsLength", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getXGrailBalance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "grailToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isTransferWhitelisted", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "maxRedeemDuration", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "minRedeemDuration", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "totalSupply", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transfer", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferFrom", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "usageAllocations", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "usagesDeallocationFee", data: BytesLike): Result;
    events: {
        "Approval(address,address,uint256)": EventFragment;
        "Transfer(address,address,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "Approval"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Transfer"): EventFragment;
}
export interface ApprovalEventObject {
    owner: string;
    spender: string;
    value: BigNumber;
}
export type ApprovalEvent = TypedEvent<[
    string,
    string,
    BigNumber
], ApprovalEventObject>;
export type ApprovalEventFilter = TypedEventFilter<ApprovalEvent>;
export interface TransferEventObject {
    from: string;
    to: string;
    value: BigNumber;
}
export type TransferEvent = TypedEvent<[
    string,
    string,
    BigNumber
], TransferEventObject>;
export type TransferEventFilter = TypedEventFilter<TransferEvent>;
export interface IXGrailToken extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: IXGrailTokenInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        allocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        allocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        allowance(owner: PromiseOrValue<string>, spender: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        approve(spender: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        approveUsage(usage: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        balanceOf(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        convertTo(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        deallocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        deallocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        getUsageApproval(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        getUserRedeem(userAddress: PromiseOrValue<string>, index: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            string,
            BigNumber
        ] & {
            grailAmount: BigNumber;
            xGrailAmount: BigNumber;
            endTime: BigNumber;
            timestamp: BigNumber;
            dividendsContract: string;
            dividendsAllocation: BigNumber;
        }>;
        getUserRedeemsLength(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        getXGrailBalance(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            allocatedAmount: BigNumber;
            redeemingAmount: BigNumber;
        }>;
        grailToken(overrides?: CallOverrides): Promise<[string]>;
        isTransferWhitelisted(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        maxRedeemDuration(overrides?: CallOverrides): Promise<[BigNumber]>;
        minRedeemDuration(overrides?: CallOverrides): Promise<[BigNumber]>;
        redeem(amount: PromiseOrValue<BigNumberish>, duration: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        totalSupply(overrides?: CallOverrides): Promise<[BigNumber]>;
        transfer(to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        transferFrom(from: PromiseOrValue<string>, to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        usageAllocations(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber] & {
            allocation: BigNumber;
        }>;
        usagesDeallocationFee(usage: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
    };
    allocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    allocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    allowance(owner: PromiseOrValue<string>, spender: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    approve(spender: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    approveUsage(usage: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    balanceOf(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    convertTo(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    deallocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    deallocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    getUsageApproval(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    getUserRedeem(userAddress: PromiseOrValue<string>, index: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber,
        string,
        BigNumber
    ] & {
        grailAmount: BigNumber;
        xGrailAmount: BigNumber;
        endTime: BigNumber;
        timestamp: BigNumber;
        dividendsContract: string;
        dividendsAllocation: BigNumber;
    }>;
    getUserRedeemsLength(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    getXGrailBalance(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber
    ] & {
        allocatedAmount: BigNumber;
        redeemingAmount: BigNumber;
    }>;
    grailToken(overrides?: CallOverrides): Promise<string>;
    isTransferWhitelisted(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    maxRedeemDuration(overrides?: CallOverrides): Promise<BigNumber>;
    minRedeemDuration(overrides?: CallOverrides): Promise<BigNumber>;
    redeem(amount: PromiseOrValue<BigNumberish>, duration: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    totalSupply(overrides?: CallOverrides): Promise<BigNumber>;
    transfer(to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    transferFrom(from: PromiseOrValue<string>, to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    usageAllocations(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    usagesDeallocationFee(usage: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    callStatic: {
        allocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<void>;
        allocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        allowance(owner: PromiseOrValue<string>, spender: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        approve(spender: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<boolean>;
        approveUsage(usage: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        balanceOf(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        convertTo(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        deallocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<void>;
        deallocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        getUsageApproval(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getUserRedeem(userAddress: PromiseOrValue<string>, index: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            string,
            BigNumber
        ] & {
            grailAmount: BigNumber;
            xGrailAmount: BigNumber;
            endTime: BigNumber;
            timestamp: BigNumber;
            dividendsContract: string;
            dividendsAllocation: BigNumber;
        }>;
        getUserRedeemsLength(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getXGrailBalance(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            allocatedAmount: BigNumber;
            redeemingAmount: BigNumber;
        }>;
        grailToken(overrides?: CallOverrides): Promise<string>;
        isTransferWhitelisted(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        maxRedeemDuration(overrides?: CallOverrides): Promise<BigNumber>;
        minRedeemDuration(overrides?: CallOverrides): Promise<BigNumber>;
        redeem(amount: PromiseOrValue<BigNumberish>, duration: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        totalSupply(overrides?: CallOverrides): Promise<BigNumber>;
        transfer(to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<boolean>;
        transferFrom(from: PromiseOrValue<string>, to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<boolean>;
        usageAllocations(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        usagesDeallocationFee(usage: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    };
    filters: {
        "Approval(address,address,uint256)"(owner?: PromiseOrValue<string> | null, spender?: PromiseOrValue<string> | null, value?: null): ApprovalEventFilter;
        Approval(owner?: PromiseOrValue<string> | null, spender?: PromiseOrValue<string> | null, value?: null): ApprovalEventFilter;
        "Transfer(address,address,uint256)"(from?: PromiseOrValue<string> | null, to?: PromiseOrValue<string> | null, value?: null): TransferEventFilter;
        Transfer(from?: PromiseOrValue<string> | null, to?: PromiseOrValue<string> | null, value?: null): TransferEventFilter;
    };
    estimateGas: {
        allocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        allocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        allowance(owner: PromiseOrValue<string>, spender: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        approve(spender: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        approveUsage(usage: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        balanceOf(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        convertTo(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        deallocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        deallocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        getUsageApproval(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getUserRedeem(userAddress: PromiseOrValue<string>, index: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getUserRedeemsLength(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        getXGrailBalance(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        grailToken(overrides?: CallOverrides): Promise<BigNumber>;
        isTransferWhitelisted(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        maxRedeemDuration(overrides?: CallOverrides): Promise<BigNumber>;
        minRedeemDuration(overrides?: CallOverrides): Promise<BigNumber>;
        redeem(amount: PromiseOrValue<BigNumberish>, duration: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        totalSupply(overrides?: CallOverrides): Promise<BigNumber>;
        transfer(to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        transferFrom(from: PromiseOrValue<string>, to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        usageAllocations(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        usagesDeallocationFee(usage: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        allocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        allocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        allowance(owner: PromiseOrValue<string>, spender: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        approve(spender: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        approveUsage(usage: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        balanceOf(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        convertTo(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        deallocate(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, usageData: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        deallocateFromUsage(userAddress: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        getUsageApproval(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getUserRedeem(userAddress: PromiseOrValue<string>, index: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getUserRedeemsLength(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getXGrailBalance(userAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        grailToken(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isTransferWhitelisted(account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        maxRedeemDuration(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        minRedeemDuration(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        redeem(amount: PromiseOrValue<BigNumberish>, duration: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        totalSupply(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        transfer(to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        transferFrom(from: PromiseOrValue<string>, to: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        usageAllocations(userAddress: PromiseOrValue<string>, usageAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        usagesDeallocationFee(usage: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
